#! /bin/sh
### BEGIN INIT INFO
# Provides:          cfengine3
# Required-Start:    $remote_fs $network $syslog
# Required-Stop:     $remote_fs $network $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: initscript for cfengine3
# Description:       starts all the daemon needed by cfengine3 if they are
#                    enabled on /etc/default/cfengine3
### END INIT INFO

# Author: Antonio Radici <antonio@dyne.org>

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin

DESC="datacenter management platform"
NAME=cfengine3
PIDROOT=/var/run/cfengine3
SCRIPTNAME=/etc/init.d/$NAME

CFEXECD_DAEMON=/usr/bin/cf-execd
CFSERVERD_DAEMON=/usr/bin/cf-serverd
CFMONITORD_DAEMON=/usr/bin/cf-monitord

#DAEMON_ARGS="--options args"
#PIDFILE=/var/run/$NAME.pid

# Exit if the package is not installed
[ -x "$CFEXECD_DAEMON" ] || exit 0
[ -x "$CFSERVERD_DAEMON" ] || exit 0
[ -x "$CFMONITORD_DAEMON" ] || exit 0

# defaults
RUN_CFMONITORD=1
RUN_CFEXECD=1
RUN_CFSERVERD=1

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions


#
# Function that checks if $PIDROOT exists
#
check_run_dir()
{
    if [ ! -d $PIDROOT ]
    then
        mkdir $PIDROOT
    fi
}

#
# Function that starts the daemon/service
#
do_start()
{
        DAEMON=$1
        DAEMON_NAME=`basename $DAEMON`
        PIDFILE="$PIDROOT/$DAEMON_NAME.pid"
        
        # get the args
        [ $DAEMON_NAME = "cf-monitord" ] && DAEMON_ARGS="$CFMONITORD_ARGS"
        [ $DAEMON_NAME = "cf-serverd" ] && DAEMON_ARGS="$CFSERVERD_ARGS"
        [ $DAEMON_NAME = "cf-execd" ] && DAEMON_ARGS="$CFEXECD_ARGS"

	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started
	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
		|| return 1
	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
		$DAEMON_ARGS \
		|| return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
        DAEMON=$1
        DAEMON_NAME=`basename $DAEMON`
        PIDFILE="$PIDROOT/$DAEMON_NAME.pid"

	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $DAEMON_NAME
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2
	# Wait for children to finish too if this is a daemon that forks
	# and if the daemon is only ever run from this initscript.
	# If the above conditions are not satisfied then add some other code
	# that waits for the process to drop all resources that could be
	# needed by services started subsequently.  A last resort is to
	# sleep for some time.
	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
	[ "$?" = 2 ] && return 2
	# Many daemons don't delete their pidfiles when they exit.
	rm -f $PIDFILE
	return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
        DAEMON=$1
        DAEMON_NAME=`basename $DAEMON`
        PIDFILE="$PIDROOT/$DAEMON_NAME.pid"

	#
	# If the daemon can reload its configuration without
	# restarting (for example, when it is sent a SIGHUP),
	# then implement that here.
	#
	start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $DAEMON_NAME
	return 0
}

# Function to start the cfengine daemons
start_cfengine() {
        RETVAL=0
        if [ "$RUN_CFMONITORD" = "1" ]; then
            do_start $CFMONITORD_DAEMON 
            [ $? = "0" ] || RETVAL=$?
        fi
        if [ "$RUN_CFSERVERD" = "1" ]; then
            do_start $CFSERVERD_DAEMON
            [ $? = "0" ] || RETVAL=$?
        fi
        if [ "$RUN_CFEXECD" = "1" ]; then
            do_start $CFEXECD_DAEMON
            [ $? = "0" ] || RETVAL=$?
        fi

        return $RETVAL
}

# Function to stop the cfengine daemons
stop_cfengine() {
        RETVAL=0
        if [ "$RUN_CFEXECD" = "1" ]; then
            do_stop $CFEXECD_DAEMON
            [ $? = "0" ] || RETVAL=$?
        fi
        if [ "$RUN_CFMONITORD" = "1" ]; then
            do_stop $CFMONITORD_DAEMON 
            [ $? = "0" ] || RETVAL=$?
        fi
        if [ "$RUN_CFSERVERD" = "1" ]; then
            do_stop $CFSERVERD_DAEMON
            [ $? = "0" ] || RETVAL=$?
        fi

        return $RETVAL
}

# Function to return the status of the cfengine daemons
status_cfengine() {
        RETVAL=0
        if [ "$RUN_CFMONITORD" = "1" ]; then
                status_of_proc "$CFMONITORD_DAEMON" "cf-monitord"
                [ $? = 0 ] || RETVAL=1 
        fi
        if [ "$RUN_CFSERVERD" = "1" ]; then
                status_of_proc "$CFSERVERD_DAEMON" "cf-serverd"
                [ $? = 0 ] || RETVAL=1 
        fi
        if [ "$RUN_CFEXECD" = "1" ]; then
                status_of_proc "$CFEXECD_DAEMON" "cf-execd" 
                [ $? = 0 ] || RETVAL=1 
        fi

        return $RETVAL
}

case "$1" in
  start)
	check_run_dir
	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
        start_cfengine 
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  stop)
	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
        stop_cfengine
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  status)
        status_cfengine
        exit $?
        ;;
  restart|force-reload)
	#
	# If the "reload" option is implemented then remove the
	# 'force-reload' alias
	#
	log_daemon_msg "Restarting $DESC" "$NAME"
	stop_cfengine
	case "$?" in
	  0|1)
                sleep 8; #otherwise the lock db becomes corrupted
		start_cfengine
		case "$?" in
			0) log_end_msg 0 ;;
			1) log_end_msg 1 ;; # Old process is still running
			*) log_end_msg 1 ;; # Failed to start
		esac
		;;
	  *)
	  	# Failed to stop
		log_end_msg 1
		;;
	esac
	;;
  *)
	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
	exit 3
	;;
esac

:
